<script lang="ts">
  import { createEventDispatcher } from "svelte";
  const dispatch = createEventDispatcher();
  function performAction(action: Action) {
    dispatch("action", action);
  }

  import { getMissionStructure, isPlayerActive } from "./theResistance";

  export let variant: "above-board" | "below-board";
  export let state: GameState;
  export let user: PlayerState | undefined;

  $: missionIndex = state.missions.length;

  $: missionSpec = getMissionStructure(state.players.length)[missionIndex];

  let selectedTeam: PlayerId[] = [];
  function handleSubmit(_: Event) {
    performAction({ ProposeTeam: { team: selectedTeam } });
  }
</script>

{#if variant === "above-board"}
  <em>
    <gs6-user userid={state.leader} /> must propose a team of {missionSpec.teamSize}.
  </em>
{:else if user && isPlayerActive(state, user.id)}
  <form on:submit|preventDefault={handleSubmit}>
    <ul>
      {#each state.players as player (player.id)}
        <li>
          <label for="select-team-{player.id}">
            <input
              id="select-team-{player.id}"
              type="checkbox"
              bind:group={selectedTeam}
              value={player.id}
            />
            <gs6-user userid={player.id} />
          </label>
        </li>
      {/each}
    </ul>
    <button
      class="primary"
      type="submit"
      disabled={selectedTeam.length !== missionSpec.teamSize}
      >Propose team!</button
    >
  </form>
{/if}

<style>
  form {
    display: flex;
    flex-direction: column;
    align-items: center;
  }

  form > *:not(:first-child) {
    margin-top: 0.67rem;
  }
  form > *:not(:last-child) {
    margin-bottom: 0.67rem;
  }

  ul {
    display: grid;
    gap: 0.5em;
    grid-template-columns: 1fr 1fr;
  }
  label {
    margin-left: 1em;
    margin-right: 1em;
    white-space: nowrap;
  }
</style>
